Index: pacemaker/pengine/test10/remote-stale-node-entry.exp
===================================================================
--- pacemaker.orig/pengine/test10/remote-stale-node-entry.exp
+++ pacemaker/pengine/test10/remote-stale-node-entry.exp
@@ -578,7 +578,7 @@
     <action_set>
       <rsc_op id="24" operation="monitor" operation_key="r192.168.122.206_monitor_0" on_node="rhel7-node2" on_node_uuid="2">
         <primitive id="r192.168.122.206" class="ocf" provider="heartbeat" type="IPaddr2"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="90000" cidr_netmask="32"  ip="192.168.122.206"/>
+        <attributes CRM_meta_on_node="rhel7-node2" CRM_meta_on_node_uuid="2" CRM_meta_op_target_rc="7" CRM_meta_timeout="90000" cidr_netmask="32"  ip="192.168.122.206"/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -587,7 +587,7 @@
     <action_set>
       <rsc_op id="12" operation="monitor" operation_key="r192.168.122.206_monitor_0" on_node="rhel7-node1" on_node_uuid="1">
         <primitive id="r192.168.122.206" class="ocf" provider="heartbeat" type="IPaddr2"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="90000" cidr_netmask="32"  ip="192.168.122.206"/>
+        <attributes CRM_meta_on_node="rhel7-node1" CRM_meta_on_node_uuid="1" CRM_meta_op_target_rc="7" CRM_meta_timeout="90000" cidr_netmask="32"  ip="192.168.122.206"/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -596,7 +596,7 @@
     <action_set>
       <rsc_op id="37" operation="monitor" operation_key="lsb-dummy_monitor_0" on_node="rhel7-node3" on_node_uuid="3">
         <primitive id="lsb-dummy" class="lsb" type="/usr/share/pacemaker/tests/cts/LSBDummy"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="90000" />
+        <attributes CRM_meta_on_node="rhel7-node3" CRM_meta_on_node_uuid="3" CRM_meta_op_target_rc="7" CRM_meta_timeout="90000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -605,7 +605,7 @@
     <action_set>
       <rsc_op id="25" operation="monitor" operation_key="lsb-dummy_monitor_0" on_node="rhel7-node2" on_node_uuid="2">
         <primitive id="lsb-dummy" class="lsb" type="/usr/share/pacemaker/tests/cts/LSBDummy"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="90000" />
+        <attributes CRM_meta_on_node="rhel7-node2" CRM_meta_on_node_uuid="2" CRM_meta_op_target_rc="7" CRM_meta_timeout="90000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -614,7 +614,7 @@
     <action_set>
       <rsc_op id="13" operation="monitor" operation_key="lsb-dummy_monitor_0" on_node="rhel7-node1" on_node_uuid="1">
         <primitive id="lsb-dummy" class="lsb" type="/usr/share/pacemaker/tests/cts/LSBDummy"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="90000" />
+        <attributes CRM_meta_on_node="rhel7-node1" CRM_meta_on_node_uuid="1" CRM_meta_op_target_rc="7" CRM_meta_timeout="90000" />
       </rsc_op>
     </action_set>
     <inputs/>
Index: pacemaker/pengine/test10/remote-start-fail.exp
===================================================================
--- pacemaker.orig/pengine/test10/remote-start-fail.exp
+++ pacemaker/pengine/test10/remote-start-fail.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="7" operation="monitor" operation_key="rhel7-auto4_monitor_60000" on_node="rhel7-auto3" on_node_uuid="3">
         <primitive id="rhel7-auto4" class="ocf" provider="pacemaker" type="remote"/>
-        <attributes CRM_meta_interval="60000" CRM_meta_name="monitor" CRM_meta_timeout="30000" />
+        <attributes CRM_meta_interval="60000" CRM_meta_name="monitor" CRM_meta_on_node="rhel7-auto3" CRM_meta_on_node_uuid="3" CRM_meta_timeout="30000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -16,7 +16,7 @@
     <action_set>
       <rsc_op id="6" operation="start" operation_key="rhel7-auto4_start_0" on_node="rhel7-auto3" on_node_uuid="3">
         <primitive id="rhel7-auto4" class="ocf" provider="pacemaker" type="remote"/>
-        <attributes CRM_meta_name="start" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_name="start" CRM_meta_on_node="rhel7-auto3" CRM_meta_on_node_uuid="3" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -29,7 +29,7 @@
     <action_set>
       <rsc_op id="2" operation="stop" operation_key="rhel7-auto4_stop_0" on_node="rhel7-auto2" on_node_uuid="2">
         <primitive id="rhel7-auto4" class="ocf" provider="pacemaker" type="remote"/>
-        <attributes CRM_meta_name="stop" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_name="stop" CRM_meta_on_node="rhel7-auto2" CRM_meta_on_node_uuid="2" CRM_meta_timeout="60000" />
         <downed>
           <node id="rhel7-auto4"/>
         </downed>
Index: pacemaker/pengine/test10/remote-startup-probes.exp
===================================================================
--- pacemaker.orig/pengine/test10/remote-startup-probes.exp
+++ pacemaker/pengine/test10/remote-startup-probes.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="14" operation="monitor" operation_key="remote1_monitor_60000" on_node="18builder" on_node_uuid="5">
         <primitive id="remote1" class="ocf" provider="pacemaker" type="remote"/>
-        <attributes CRM_meta_interval="60000" CRM_meta_name="monitor" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_interval="60000" CRM_meta_name="monitor" CRM_meta_on_node="18builder" CRM_meta_on_node_uuid="5" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -16,7 +16,7 @@
     <action_set>
       <rsc_op id="13" operation="start" operation_key="remote1_start_0" on_node="18builder" on_node_uuid="5">
         <primitive id="remote1" class="ocf" provider="pacemaker" type="remote"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="18builder" CRM_meta_on_node_uuid="5" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -25,7 +25,7 @@
     <action_set>
       <rsc_op id="17" operation="monitor" operation_key="FAKE1_monitor_60000" on_node="18node2" on_node_uuid="2">
         <primitive id="FAKE1" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_interval="60000" CRM_meta_name="monitor" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_interval="60000" CRM_meta_name="monitor" CRM_meta_on_node="18node2" CRM_meta_on_node_uuid="2" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -38,7 +38,7 @@
     <action_set>
       <rsc_op id="16" operation="start" operation_key="FAKE1_start_0" on_node="18node2" on_node_uuid="2">
         <primitive id="FAKE1" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="18node2" CRM_meta_on_node_uuid="2" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -54,7 +54,7 @@
     <action_set>
       <rsc_op id="15" operation="stop" operation_key="FAKE1_stop_0" on_node="18builder" on_node_uuid="5">
         <primitive id="FAKE1" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="18builder" CRM_meta_on_node_uuid="5" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -67,7 +67,7 @@
     <action_set>
       <rsc_op id="7" operation="monitor" operation_key="FAKE1_monitor_0" on_node="remote1" on_node_uuid="remote1" router_node="18builder">
         <primitive id="FAKE1" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="remote1" CRM_meta_on_node_uuid="remote1" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -80,7 +80,7 @@
     <action_set>
       <rsc_op id="20" operation="monitor" operation_key="FAKE2_monitor_60000" on_node="remote1" on_node_uuid="remote1" router_node="18builder">
         <primitive id="FAKE2" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_interval="60000" CRM_meta_name="monitor" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_interval="60000" CRM_meta_name="monitor" CRM_meta_on_node="remote1" CRM_meta_on_node_uuid="remote1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -96,7 +96,7 @@
     <action_set>
       <rsc_op id="19" operation="start" operation_key="FAKE2_start_0" on_node="remote1" on_node_uuid="remote1" router_node="18builder">
         <primitive id="FAKE2" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="remote1" CRM_meta_on_node_uuid="remote1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -115,7 +115,7 @@
     <action_set>
       <rsc_op id="18" operation="stop" operation_key="FAKE2_stop_0" on_node="18node2" on_node_uuid="2">
         <primitive id="FAKE2" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="18node2" CRM_meta_on_node_uuid="2" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -128,7 +128,7 @@
     <action_set>
       <rsc_op id="8" operation="monitor" operation_key="FAKE2_monitor_0" on_node="remote1" on_node_uuid="remote1" router_node="18builder">
         <primitive id="FAKE2" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="remote1" CRM_meta_on_node_uuid="remote1" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -141,7 +141,7 @@
     <action_set>
       <rsc_op id="9" operation="monitor" operation_key="FAKE3_monitor_0" on_node="remote1" on_node_uuid="remote1" router_node="18builder">
         <primitive id="FAKE3" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="remote1" CRM_meta_on_node_uuid="remote1" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -154,7 +154,7 @@
     <action_set>
       <rsc_op id="10" operation="monitor" operation_key="FAKE4_monitor_0" on_node="remote1" on_node_uuid="remote1" router_node="18builder">
         <primitive id="FAKE4" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="remote1" CRM_meta_on_node_uuid="remote1" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
Index: pacemaker/pengine/test10/remote-startup.exp
===================================================================
--- pacemaker.orig/pengine/test10/remote-startup.exp
+++ pacemaker/pengine/test10/remote-startup.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="12" operation="monitor" operation_key="shooter_monitor_60000" on_node="18node1" on_node_uuid="1">
         <primitive id="shooter" class="stonith" type="fence_xvm"/>
-        <attributes CRM_meta_interval="60000" CRM_meta_name="monitor" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_interval="60000" CRM_meta_name="monitor" CRM_meta_on_node="18node1" CRM_meta_on_node_uuid="1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -16,7 +16,7 @@
     <action_set>
       <rsc_op id="11" operation="start" operation_key="shooter_start_0" on_node="18node1" on_node_uuid="1">
         <primitive id="shooter" class="stonith" type="fence_xvm"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="18node1" CRM_meta_on_node_uuid="1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -29,7 +29,7 @@
     <action_set>
       <rsc_op id="10" operation="stop" operation_key="shooter_stop_0" on_node="18builder" on_node_uuid="5">
         <primitive id="shooter" class="stonith" type="fence_xvm"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="18builder" CRM_meta_on_node_uuid="5" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -38,7 +38,7 @@
     <action_set>
       <rsc_op id="13" operation="start" operation_key="fake_start_0" on_node="18node2" on_node_uuid="2">
         <primitive id="fake" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="18node2" CRM_meta_on_node_uuid="2" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -60,7 +60,7 @@
     <action_set>
       <rsc_op id="9" operation="monitor" operation_key="fake_monitor_0" on_node="remote1" on_node_uuid="remote1" router_node="18builder">
         <primitive id="fake" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="remote1" CRM_meta_on_node_uuid="remote1" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -73,7 +73,7 @@
     <action_set>
       <rsc_op id="7" operation="monitor" operation_key="fake_monitor_0" on_node="18node2" on_node_uuid="2">
         <primitive id="fake" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="18node2" CRM_meta_on_node_uuid="2" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -82,7 +82,7 @@
     <action_set>
       <rsc_op id="5" operation="monitor" operation_key="fake_monitor_0" on_node="18node1" on_node_uuid="1">
         <primitive id="fake" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="18node1" CRM_meta_on_node_uuid="1" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -91,7 +91,7 @@
     <action_set>
       <rsc_op id="3" operation="monitor" operation_key="fake_monitor_0" on_node="18builder" on_node_uuid="5">
         <primitive id="fake" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="18builder" CRM_meta_on_node_uuid="5" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -100,7 +100,7 @@
     <action_set>
       <rsc_op id="15" operation="monitor" operation_key="remote1_monitor_60000" on_node="18builder" on_node_uuid="5">
         <primitive id="remote1" class="ocf" provider="pacemaker" type="remote"/>
-        <attributes CRM_meta_interval="60000" CRM_meta_name="monitor" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_interval="60000" CRM_meta_name="monitor" CRM_meta_on_node="18builder" CRM_meta_on_node_uuid="5" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -113,7 +113,7 @@
     <action_set>
       <rsc_op id="14" operation="start" operation_key="remote1_start_0" on_node="18builder" on_node_uuid="5">
         <primitive id="remote1" class="ocf" provider="pacemaker" type="remote"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="18builder" CRM_meta_on_node_uuid="5" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -132,7 +132,7 @@
     <action_set>
       <rsc_op id="8" operation="monitor" operation_key="remote1_monitor_0" on_node="18node2" on_node_uuid="2">
         <primitive id="remote1" class="ocf" provider="pacemaker" type="remote"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="18node2" CRM_meta_on_node_uuid="2" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -141,7 +141,7 @@
     <action_set>
       <rsc_op id="6" operation="monitor" operation_key="remote1_monitor_0" on_node="18node1" on_node_uuid="1">
         <primitive id="remote1" class="ocf" provider="pacemaker" type="remote"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="18node1" CRM_meta_on_node_uuid="1" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -150,7 +150,7 @@
     <action_set>
       <rsc_op id="4" operation="monitor" operation_key="remote1_monitor_0" on_node="18builder" on_node_uuid="5">
         <primitive id="remote1" class="ocf" provider="pacemaker" type="remote"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="18builder" CRM_meta_on_node_uuid="5" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
Index: pacemaker/pengine/test10/remote-unclean2.exp
===================================================================
--- pacemaker.orig/pengine/test10/remote-unclean2.exp
+++ pacemaker/pengine/test10/remote-unclean2.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="7" operation="start" operation_key="rhel7-auto4_start_0" on_node="rhel7-auto1" on_node_uuid="1">
         <primitive id="rhel7-auto4" class="ocf" provider="pacemaker" type="remote"/>
-        <attributes CRM_meta_name="start" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_name="start" CRM_meta_on_node="rhel7-auto1" CRM_meta_on_node_uuid="1" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -19,7 +19,7 @@
     <action_set>
       <rsc_op id="2" operation="stop" operation_key="rhel7-auto4_stop_0" on_node="rhel7-auto1" on_node_uuid="1">
         <primitive id="rhel7-auto4" class="ocf" provider="pacemaker" type="remote"/>
-        <attributes CRM_meta_name="stop" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_name="stop" CRM_meta_on_node="rhel7-auto1" CRM_meta_on_node_uuid="1" CRM_meta_timeout="60000" />
         <downed>
           <node id="rhel7-auto4"/>
         </downed>
@@ -31,7 +31,7 @@
     <action_set>
       <rsc_op id="1" operation="monitor" operation_key="rhel7-auto4_monitor_60000" on_node="rhel7-auto1" on_node_uuid="1">
         <primitive id="rhel7-auto4" class="ocf" provider="pacemaker" type="remote"/>
-        <attributes CRM_meta_interval="60000" CRM_meta_name="monitor" CRM_meta_timeout="30000" />
+        <attributes CRM_meta_interval="60000" CRM_meta_name="monitor" CRM_meta_on_node="rhel7-auto1" CRM_meta_on_node_uuid="1" CRM_meta_timeout="30000" />
       </rsc_op>
     </action_set>
     <inputs>
Index: pacemaker/pengine/test10/reprobe-target_rc.exp
===================================================================
--- pacemaker.orig/pengine/test10/reprobe-target_rc.exp
+++ pacemaker/pengine/test10/reprobe-target_rc.exp
@@ -2,7 +2,7 @@
   <synapse id="0">
     <action_set>
       <rsc_op id="3" operation="probe_again" operation_key="probe_again-node-1" on_node="node-1" on_node_uuid="node-1">
-        <attributes CRM_meta_op_no_wait="true" />
+        <attributes CRM_meta_on_node="node-1" CRM_meta_on_node_uuid="node-1" CRM_meta_op_no_wait="true" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -10,7 +10,7 @@
   <synapse id="1">
     <action_set>
       <rsc_op id="2" operation="probe_again" operation_key="probe_again-node-0" on_node="node-0" on_node_uuid="node-0">
-        <attributes CRM_meta_op_no_wait="true" />
+        <attributes CRM_meta_on_node="node-0" CRM_meta_on_node_uuid="node-0" CRM_meta_op_no_wait="true" />
       </rsc_op>
     </action_set>
     <inputs/>
